#include <acknex.h>
#include <default.c>

#define i_am_game_ball FLAG1

var movement_state = 0,
current_level = 0,
game_over = 0,
num_balls = 0,
num_balls_in_level = 0,
level = 1,
lives = 3,
scores = 0,
kick_force = 0,
kick_force_temp = 0,
camera_distance = 140,
camera_distance_up = 40,
up_cam_limit = 80,
down_cam_limit = -70,
player_down = 0,
orbit_camera_dist = 0,
orbit_camera_pan = 0,
orbit_camera_tilt = 0;

STRING* game_over_str = "";
STRING* next_level_str = "";
STRING* scores_str = "";
SOUND* pong_snd = "tap.wav";
ENTITY* main_ball_ent;
ENTITY* game_radius_ent;
VECTOR camera_center_vec, camera_pos_vec;

TEXT* help_txt =
{
	font = "Calibri#24b";
	string("Magic Balls
	'100 Lines' game
	Lite-C project
	Created by Mironov Vasily \n
	Move mouse - rotate camera
	Space or Mouse Left - kick the ball"); 
	flags = SHADOW | VISIBLE;
}

TEXT* game_over_txt =
{
	font = "Calibri#48b";
	string(game_over_str); 
	flags = SHADOW;
}

PANEL* kick_force_pan =
{
	bmap = "forcemetr_font.tga";
	pos_x = 874;
	pos_y = 626;
	window(75, 23, 55, 99, "forcemetr.bmp", 0, kick_force_temp);
	digits(55, -25, "Force: %.0f", "Calibri#24b", 1, kick_force);
	digits(55, -50, "Scores: %.0f", "Calibri#24b", 1, scores);
	digits(55, -75, "Lives: %.0f", "Calibri#24b", 1, lives);
	digits(55, -100, "Level: %.0f", "Calibri#24b", 1, level);
	flags = VISIBLE;
}

void main_ball_plop()
{
	var snd_handle = 0;
	if (event_type == EVENT_ENTITY)
	{
		if (is(you,FLAG1))
		{
			if (snd_playing(snd_handle) == 0)
			{
				snd_handle = ent_playsound(main_ball_ent, pong_snd, 60);
			}
		}
	}
}

void kick_main_ball()
{
	VECTOR kick_vec;
	movement_state = 1;
	vec_set(kick_vec.x, vector(kick_force, 0, 20));
	vec_rotate(kick_vec, camera.pan);
	phent_addvelcentral(main_ball_ent, kick_vec);
	wait(-1.5);
	movement_state = 0;
}

void game_balls_parameters(var _mass, var _flag1)
{
	my.event = main_ball_plop;
	my.emask |= ENABLE_FRICTION | ENABLE_ENTITY;
	if (_flag1 == 1)
	{
		set(my,POLYGON | SHADOW | FLAG1);
	}
	else
	{
		set(my,POLYGON | SHADOW);
	}
	my.material = mat_metal;
	phent_settype(my, PH_RIGID, PH_SPHERE);
	phent_setmass(my, _mass, PH_SPHERE);
	phent_setfriction(my, 30);
	phent_setelasticity(my, 30, 100);
	phent_setdamping(my, 30, 5);
	ph_setgravity(vector(0, 0, -386));
}

void game_ball()
{
	my.skin = integer(1 + random(4));
	game_balls_parameters(0.2, 1);
	
	while (my)
	{
		//         - game over =)
		if (vec_dist(my.x, game_radius_ent.x) > 580)
		{
			scores = scores + 1;
			wait(-3);
			ent_remove(my);
			num_balls_in_level -=1;
		}
		wait(1);
	}
}

void main_ball()
{
	game_balls_parameters(1, 0);
}

void copy_scores(STRING* copy_str, STRING* message_str)
{
	str_cat(copy_str, str_for_num(scores_str, scores));
	str_cat(copy_str, message_str);
	(game_over_txt.pstring)[0] = copy_str;
	set(game_over_txt,VISIBLE);
}

action act_game_radius()
{
	game_radius_ent = my;
}

void main()
{
	video_mode = 8;
	video_screen = 1;
	shadow_stencil = 1;
	camera.clip_near = 0;
	fps_max = 60;
	level_load("level.wmb");
	wait(5);
	ent_createlayer("skycube+6.tga", SKY | CUBE | VISIBLE, 1);
	
	// texts positions
	game_over_txt.pos_x = screen_size.x/2 - 230;
	game_over_txt.pos_y = screen_size.y/2 - 30;
	
	while (game_over == 0)
	{
		kick_force_temp = kick_force/2;
		
		//      ,   
		if (current_level != level)
		{
			// change level
			current_level = level;
			// create player ball
			if (main_ball_ent != 0) {ent_remove(main_ball_ent);}
			main_ball_ent = ent_create("ball.mdl", vector(0, 0, 30), main_ball);
			// create game ball(for scores)
			for (num_balls = 0; num_balls < 5 + random(5); num_balls++)
			{
				num_balls_in_level = num_balls_in_level + 1;
				ent_create("ball.mdl", vector(random(400) - random(400), random(400) - random(400), 30), game_ball);
			}
		}
		
		//     ,    
		if (num_balls_in_level == 0)
		{
			str_cpy(next_level_str, "   You win, you scores: ");
			copy_scores(next_level_str, "\n Press SPACE to next level");
			while (key_space == 0) {wait(1);}
			level = level + 1;
			reset(game_over_txt,VISIBLE);
		}
		
		//         - game over =)
		if (vec_dist(main_ball_ent.x, game_radius_ent.x) > 580)
		{
			lives = lives - 1;
			ent_remove(main_ball_ent);
			main_ball_ent = ent_create("ball.mdl", vector(0, 0, 30), main_ball);
		}
		
		//         - game over =)
		if (vec_dist(main_ball_ent.x, game_radius_ent.x) > 580)
		{
			lives = lives - 1;
			ent_remove(main_ball_ent);
			main_ball_ent = ent_create("ball.mdl", vector(0, 0, 30), main_ball);
		}
		
		//   ,  game over =)
		if (lives == 0)
		{
			str_cpy(game_over_str, "Game Over, you scores: ");
			copy_scores(game_over_str, "\n     Press ESCAPE to exit");
			game_over = 1;
		}
		
		//       
		if ((key_space || mouse_left) && movement_state == 0)
		{
			// 600 -   
			if (kick_force < 800)
			{
				kick_force += 8;//  
			}
		}
		else
		{
			//   ,     
			if (kick_force > 0) {kick_main_ball();}
			kick_force = 0;
		}
		
		//     
		vec_set(camera_center_vec.x, main_ball_ent.x);
		
		//    
		camera_center_vec.z = (main_ball_ent.z + camera_distance_up);

		//   
		orbit_camera_dist = fcos(orbit_camera_tilt, camera_distance);
		
		vec_set(camera_pos_vec.x, vector(camera_center_vec.x - fcos(orbit_camera_pan, orbit_camera_dist),
		camera_center_vec.y - fsin(orbit_camera_pan, orbit_camera_dist),
		camera_center_vec.z + fsin(orbit_camera_tilt, camera_distance)));
		
		//     pan
		vec_set(camera.pan, vector(orbit_camera_pan, -orbit_camera_tilt, 0));
		
		//        
		vec_set(camera.x, camera_pos_vec.x);
		
		//   
		orbit_camera_pan -= mouse_force.x * 8 * time_step;
		orbit_camera_tilt -= mouse_force.y * 8 * time_step;
		
		orbit_camera_tilt = clamp(orbit_camera_tilt, -20, 90);//  
		wait(1);
	}
}
